<template>
  <div id="container">
    <div id="global-sidebar" class="d-flex align-items-start flex-column">
      <div class="logo">
        <div class="placeholder-logo">&nbsp;</div>
        <div class="logo-text">
          <span class="indent">Indent</span><span class="dot">.</span><span class="cloud">Cloud</span>
        </div>
      </div>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="tasks" />
        </div>
        <div class="text">
          Issue Tracking
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="book" />
        </div>
        <div class="text">
          Wiki
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon :icon="['fab', 'git-alt']" />
        </div>
        <div class="text">
          Source Control
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="server" />
        </div>
        <div class="text">
          CI/CD
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="boxes" />
        </div>
        <div class="text">
          Artifacts
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="tachometer-alt" />
        </div>
        <div class="text">
          Operations
        </div>
      </a>

      <a href="#" class="gs-item gs-navigation-item">
        <div class="icon">
          <font-awesome-icon icon="key" />
        </div>
        <div class="text">
          Keystore
        </div>
      </a>

      <div href="#" class="gs-item user-profile mt-auto">
        <img src="https://secure.gravatar.com/avatar/700996b587d8cc39e1b3257db3aa3334?s=64&d=identicon" />

        <div class="text">
          @aaron.claydon
          <div class="links">
            <router-link to="/profile">My Profile</router-link> |
            <router-link to="/logout">Logout</router-link>
          </div>
        </div>
      </div>
    </div>

    <div id="app-sidebar">
      <div id="app-sidebar-content">
        <h2>Issues</h2>
        wow
      </div>
    </div>
    <div id="main-window">
      <div id="main-window-content">
        <b-breadcrumb :items="breadcrumb_navigation"></b-breadcrumb>

        <div class="issue-view">
          <h1>
            Implement NGINX wildcard ingress
            <b-badge class="item-state" variant="primary">In Progress</b-badge>
          </h1>
          <b-card>
            <div class="details-split-view">
              <div class="main-info">
                <div class="fields">
                  some fields
                </div>
                <div class="description">
                  description
                </div>
              </div>
              <div class="side-info">
                <div class="field" id="asignee">
                  <span class="name">
                    Asigned
                  </span>
                  <span class="value">
                    Aaron Claydon
                  </span>
                </div>
                <div class="field" id="asignee">
                  <span class="name">
                    Reporter
                  </span>
                  <span class="value">
                    Aaron Claydon
                  </span>
                </div>

                <el-divider></el-divider>
                <div class="field" id="asignee">
                  <span class="name">
                    Created
                  </span>
                  <span class="value">
                    16/03/19 12:32
                  </span>
                </div>
                <div class="field" id="asignee">
                  <span class="name">
                    Updated
                  </span>
                  <span class="value">
                    two hours ago
                  </span>
                </div>

                <el-divider></el-divider>
                <div>developer info</div>

                <el-divider></el-divider>
                <div>time tracking</div>
              </div>
            </div>
          </b-card>

          <h3>Comments</h3>
          <b-card>
            <div class="comments">
              comments
            </div>
          </b-card>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss">
$brand-color-1: #e8c24a;

.el-menu-vertical-demo:not(.el-menu--collapse) {
  width: 200px;
  min-height: 400px;
}

html {
	height: 100%;
}

body {
	margin: 0;
	height: 100%;
}

#container {
	height: 100%;
}

.breadcrumb {
  border: 0;
  background-color: transparent;
  border-bottom: 1px solid rgb(229, 229, 229);
  padding: 5px 5px 10px 5px;
}

$global-sidebar-width: 64px;
$application-sidebar-width: 256px;

#global-sidebar {
	display: inline-block;
	vertical-align: top;
	height: 100%;
	width: $global-sidebar-width;
  overflow: auto;
  background-color: #3e3c3c;
  color: white;
  border: 0;
  position: absolute;
  top: 0;
  left: 0;

  transition-property: width;
  transition-duration: 0.2s;
  transition-timing-function: ease-in-out;

  &:hover {
    width: 256px;
  }

  &:hover .logo .logo-text {
    display: block;
  }

  @mixin gs-item($size) {
    display: flex;
    width: 200px;
    overflow: hidden;
    align-items: center;
    margin: ($global-sidebar-width - $size) / 2;
    color: white;

    .icon {
      width: $size;
      height: $size + 2;
      font-size: $size;
      padding: 0;
      line-height: $size + 2;
      text-align: center;
    }

    .text {
      margin-left: 14px;
      display: none;
      font-size: 16px;
    }
  }

  .gs-navigation-item {
    @include gs-item(22px);

    &:hover {
      color: $brand-color-1;
    }
  }
  .user-profile {
    $size: 44px;
    @include gs-item($size);

    align-items: flex-start;

    img {
      width: $size;
      height: $size;
      border-radius: 4px;
    }

    .links {
      font-size: 11px;
    }
  }
  &:hover .gs-item  .text {
    display: block;
  }

  .logo {
    $size: 32px;
    display: flex;
    width: 200px;
    overflow: hidden;
    align-items: center;
    margin: ($global-sidebar-width - $size) / 2;

    .placeholder-logo {
      width: $size;
      height: $size;
      background-color: #4a78e8;
      border-radius: 3px;
      text-align: center;
      font-size: 28px;
      color: white;
    }

    .logo-text {
      display: none;
      font-size: 20px;
      margin-left: 14px;

      .indent {
        color: #4a78e8;
        font-weight: 500;
      }

      .dot {
        color: #c3c3c3;
        padding-left: 2px;
      }

      .cloud {
        color: $brand-color-1;
        font-weight: 200;
      }
    }
  }

  .bottom-elements {
    width: 100%;
    position: absolute;
    bottom: 0;
    left: 0;

    &.settings {
      bottom: 56px;
    }
    &.help {
      bottom: 56px * 2;
    }
  }
}

#app-sidebar {
	display: inline-block;
	vertical-align: top;
	height: 100%;
	width: $application-sidebar-width;
  overflow: auto;
  background-color: #2176ce;
  color: white;
  margin-left: $global-sidebar-width;

  #app-sidebar-content {
    padding: 15px 25px 25px 25px;
  }

  h2 {
    padding: 0;
    margin: 0;
  }
}

#main-window {
	display: inline-block;
	vertical-align: top;
	height: 100%;
	width: calc(100% - #{$global-sidebar-width} - #{$application-sidebar-width});
  overflow: auto;
  
  #main-window-content {
    padding: 15px 25px 25px 25px;
  }
}

.issue-view {
  .field {
    .name {
      font-weight: 500;

      &::after { 
        content: ': ';
      }
    }
  }

  .item-state {
    font-size: 18px;
  }

  .main-info, .side-info {
    display: inline-block;
    vertical-align: top;
  }
  .main-info {
    width: calc(100% - 320px);
  }
  .side-info {
    width: 320px;
  }
}
</style>

<script>
  export default {
    data() {
      return {
        global_nav_collapse: true,
        breadcrumb_navigation: [
          {
            text: 'Projects',
            href: '#'
          },
          {
            text: 'Infrastructure',
            href: '#'
          },
          {
            text: 'INFRA-4234',
            active: true
          }
        ]
      };
    },
    methods: {

    }
  }
</script>